nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Types | Public Member Functions | Protected Member Functions | List of all members
nx::sdk::analytics::Integration Class Reference

`#include <integration.h>`

Inheritance diagram for nx::sdk::analytics::Integration:

## Public Types
using | CreateEngine = std::function< IEngine *(Integration *integration)>

## Public Member Functions
| Integration (std::string integrationManifest, CreateEngine createEngine)
Ptr< IUtilityProvider > | utilityProvider () const
virtual std::string | instanceId () const
virtual void | setUtilityProvider (IUtilityProvider *utilityProvider) override
Public Member Functions inherited from nx::sdk::RefCountable< IIntegration >
| RefCountable (const RefCountable &)=delete
| RefCountable (RefCountable &&)=delete
RefCountable & | operator= (const RefCountable &)=delete
RefCountable & | operator= (RefCountable &&)=delete
virtual int | addRef () const override
virtual int | releaseRef () const override
int | refCount () const
Public Member Functions inherited from nx::sdk::Interface< IIntegration >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
int | refCountThreadUnsafe () const

## Protected Member Functions
virtual Result< IEngine * > | doObtainEngine ()
virtual std::string | manifestString () const
virtual void | getManifest (Result< const IString *> *outResult) const override
virtual void | doCreateEngine (Result< IEngine *> *outResult) override
Protected Member Functions inherited from nx::sdk::Interface< IIntegration >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)

## Additional Inherited Members
Static Public Member Functions inherited from nx::sdk::IIntegration
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static const InterfaceId * | makeId (const char(&charArray)[len])
template<int len, int alternativeLen>
static std::vector< const InterfaceId * > | makeIdWithAlternative (const char(&charArray)[len], const char(&alternativeCharArray)[alternativeLen])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])
static std::vector< const InterfaceId * > | alternativeInterfaceIds (const InterfaceId *id)
static std::vector< const InterfaceId * > | alternativeInterfaceIds (std::vector< const InterfaceId *> ids)

## Detailed Description

Base class for a typical implementation of an Analytics Integration. Hides many technical details of the SDK, but may limit plugin capabilities - use only when suitable.

## Constructor & Destructor Documentation

## ◆ Integration()

nx::sdk::analytics::Integration::Integration | ( | std::string | integrationManifest,
|  | CreateEngine | createEngine
| ) |  |

Allows to use this class directly without inhering it.

Deprecated:
  Instead of using this constructor, create a subclass, override doObtainEngine() and manifestString().

Parameters

  integrationManifest | Integration manifest to be returned from manifest().
  createEngine | Functor for Engine creation.

## Member Function Documentation

## ◆ doObtainEngine()

Result< IEngine * > nx::sdk::analytics::Integration::doObtainEngine | ( |  | ) |
| protectedvirtual

Override this method instead of doCreateEngine().

Reimplemented in nx::vms_server_plugins::analytics::stub::custom_metadata::Integration, nx::vms_server_plugins::analytics::stub::diagnostic_events::Integration, nx::vms_server_plugins::analytics::stub::error_reporting::Integration, nx::vms_server_plugins::analytics::stub::events::Integration, nx::vms_server_plugins::analytics::stub::motion_metadata::Integration, nx::vms_server_plugins::analytics::stub::roi::Integration, nx::vms_server_plugins::analytics::stub::sdk_features::Integration, nx::vms_server_plugins::analytics::stub::settings::Integration, nx::vms_server_plugins::analytics::stub::special_objects::Integration, nx::vms_server_plugins::analytics::stub::video_frames::Integration, nx::vms_server_plugins::analytics::stub::best_shots::Integration, nx::vms_server_plugins::analytics::stub::object_actions::Integration, nx::vms_server_plugins::analytics::stub::object_detection::Integration, nx::vms_server_plugins::analytics::stub::object_streamer::Integration, nx::vms_server_plugins::analytics::stub::taxonomy_features::Integration, nx::vms_server_plugins::analytics::sample::Integration, and nx::vms_server_plugins::analytics::stub::http_requests::Integration.

## ◆ instanceId()

virtual std::string nx::sdk::analytics::Integration::instanceId | ( |  | ) | const
| inlinevirtual

Override for multi-IIntegration libraries; provide integrationId specified in the Manifest.

Reimplemented in nx::vms_server_plugins::analytics::stub::custom_metadata::Integration, nx::vms_server_plugins::analytics::stub::diagnostic_events::Integration, nx::vms_server_plugins::analytics::stub::error_reporting::Integration, nx::vms_server_plugins::analytics::stub::events::Integration, nx::vms_server_plugins::analytics::stub::motion_metadata::Integration, nx::vms_server_plugins::analytics::stub::roi::Integration, nx::vms_server_plugins::analytics::stub::sdk_features::Integration, nx::vms_server_plugins::analytics::stub::settings::Integration, nx::vms_server_plugins::analytics::stub::special_objects::Integration, nx::vms_server_plugins::analytics::stub::video_frames::Integration, and nx::vms_server_plugins::analytics::stub::taxonomy_features::Integration.

## ◆ setUtilityProvider()

void nx::sdk::analytics::Integration::setUtilityProvider | ( | IUtilityProvider * | utilityProvider | ) |
| overridevirtual

Provides an object which the Integration can use for calling back to access some data and functionality provided by the process that uses the Integration.

For the details, see the documentation for IUtilityProvider.

Implements nx::sdk::IIntegration.

The documentation for this class was generated from the following files:

- src/nx/sdk/analytics/helpers/integration.h
- src/nx/sdk/analytics/helpers/integration.cpp